#ifndef  _QV_SUB_FIELD_
#define  _QV_SUB_FIELD_

#include <QvField.h>
#include <QvInput.h>

/////////////////////////////////////////////////////////////////////////////

#define QV_SFIELD_HEADER(className)                       \
  public:                                     \
    className();                                  \
    virtual ~className();                             \
    virtual QvBool readValue(QvInput *in)

/////////////////////////////////////////////////////////////////////////////

#define QV_MFIELD_HEADER(className)                       \
  public:                                     \
    className();                                  \
    virtual ~className();                             \
    virtual QvBool  read1Value(QvInput *in, unsigned int index);           \
    void        allocValues(unsigned int newNum);                  \
  protected:                                      \
    static QvBool   canUseMalloc

/////////////////////////////////////////////////////////////////////////////

#define QV_SFIELD_SOURCE(className)                       \
                                          \
className::className()                                \
{                                         \
}                                         \
className::~className()                               \
{                                         \
}
                                     
/////////////////////////////////////////////////////////////////////////////
// WIN16/32
/////////////////////////////////////////////////////////////////////////////

#if defined (WIN32) || defined (WIN16)
// Note: field types whose values require constructors to be called
// should pass TRUE for valueHasConstructor. Otherwise, pass FALSE.
#define QV_MFIELD_SOURCE(className, valueType, numValues, valueHasConstructor)\
                                          \
QvBool className::canUseMalloc;                           \
                                          \
className::className()                                \
{                                         \
    canUseMalloc = ! valueHasConstructor;                     \
    values = NULL;                                \
    hGlobalBuffer = NULL ;                   \
    /* Make room for 1 value to start */                      \
    allocValues(1);                               \
}                                         \
                                          \
className::~className()                               \
{                                         \
    if (values && canUseMalloc && hGlobalBuffer) {                             \
        GlobalUnlock( hGlobalBuffer) ; \
        GlobalFree( hGlobalBuffer ) ;   \
        hGlobalBuffer = NULL ;        \
    }                                          \
    else if (values) {                                     \
        delete [] values;                             \
    }                                         \
}                                         \
                                          \
void                                          \
className::allocValues(unsigned int newNum)                        \
{                                         \
    if (!values && newNum > 0 && canUseMalloc) {                             \
        hGlobalBuffer     = GlobalAlloc( GHND, (numValues * sizeof(valueType)) * ((unsigned long)newNum) ) ; \
        if ( hGlobalBuffer )  \
            values = ( valueType * ) GlobalLock(hGlobalBuffer) ; \
    }                                          \
    else if (!values && newNum > 0) {                                  \
        values = new valueType[numValues * newNum];           \
    }                                         \
    else if (values && newNum > 0 && hGlobalBuffer && canUseMalloc) {                                    \
        GlobalUnlock( hGlobalBuffer) ; \
        hGlobalBuffer = GlobalReAlloc( hGlobalBuffer, (numValues * sizeof(valueType)) * ((unsigned long)newNum), GMEM_MOVEABLE ) ; \
        if ( hGlobalBuffer )  \
              values = (valueType *)GlobalLock( hGlobalBuffer ) ; \
    }                                           \
    else if (values && newNum > 0) {                                    \
        valueType *oldValues = values;                    \
        values = new valueType[numValues * newNum];           \
        for (unsigned int i = 0; i < num && i < newNum; i++)           \
            values[i] = oldValues[i];                     \
        delete [] oldValues;                          \
    }                                     \
    else if (values && hGlobalBuffer && canUseMalloc)  {        \
        GlobalUnlock( hGlobalBuffer) ;          \
        GlobalFree( hGlobalBuffer ) ;           \
        hGlobalBuffer = NULL ;                  \
        values = NULL;                          \
    }                                         \
    else if (values) {                                    \
        delete [] values;                         \
        values = NULL;                            \
    }                                     \
    else {                                      \
        values = NULL ;                         \
    }                                           \
    num = maxNum = newNum;                            \
}    

/////////////////////////////////////////////////////////////////////////////
// IRIX
/////////////////////////////////////////////////////////////////////////////

#else                                     
/////////////////////////////////////////////////////////////////////////////

// Note: field types whose values require constructors to be called
// should pass TRUE for valueHasConstructor. Otherwise, pass FALSE.
#define QV_MFIELD_SOURCE(className, valueType, numValues, valueHasConstructor)\
                                          \
QvBool className::canUseMalloc;                           \
                                          \
className::className()                                \
{                                         \
    canUseMalloc = ! valueHasConstructor;                     \
    values = NULL;                                \
    /* Make room for 1 value to start */                      \
    allocValues(1);                               \
}                                         \
                                          \
className::~className()                               \
{                                         \
    if (values != NULL) {                             \
    if (canUseMalloc)                             \
        free((char *) values);                        \
    else                                      \
        delete [] values;                             \
    }                                         \
}                                         \
                                          \
void                                          \
className::allocValues(int newNum)                        \
{                                         \
    if (values == NULL) {                             \
    if (newNum > 0) {                             \
        if (canUseMalloc)                             \
        values = (valueType *)                        \
            malloc(numValues * sizeof(valueType) * newNum);       \
        else                                  \
        values = new valueType[numValues * newNum];           \
    }                                     \
    }                                         \
    else {                                    \
    if (newNum > 0) {                             \
        if (canUseMalloc)                             \
        values = (valueType *)                        \
            realloc(values, numValues * sizeof(valueType) * newNum);  \
        else {                                \
        valueType *oldValues = values;                    \
        values = new valueType[numValues * newNum];           \
        for (int i = 0; i < num && i < newNum; i++)           \
            values[i] = oldValues[i];                     \
        delete [] oldValues;                          \
        }                                     \
    }                                     \
    else {                                    \
        if (canUseMalloc)                             \
        free((char *) values);                        \
        else                                  \
        delete [] values;                         \
        values = NULL;                            \
    }                                     \
    }                                         \
    num = maxNum = newNum;                            \
}    
#endif // Win16/32

#endif /* _QV_SUB_FIELD_ */
