#include <QvElem.h>
    
#if defined (WIN16) || defined (WIN32)                           
    #include "windows.h"
#endif    
    
const char *QvElement::nodeTypeNames[NumNodeTypes] = {
    "Unknown",
    "OrthographicCamera",
    "PerspectiveCamera",
    "DirectionalLight",
    "PointLight",
    "SpotLight",
    "NoOpTransform",
    "MatrixTransform",
    "Rotation",
    "Scale",
    "Transform",
    "Translation",
};

QvElement::QvElement()
{
    // These will be set to something real when the element is
    // added to the state
    depth = -1;
    next = NULL;

    // Presumably, the caller will set these
    data = NULL;
    type = Unknown;
}

QvElement::~QvElement()
{
}

void
QvElement::print()
{   
#if defined (WIN16) || defined (WIN32)   
    char    szStringSpace[1024] ;                        
    sprintf(szStringSpace,"\t\tElement of type %s\n", nodeTypeNames[type]); 
    MessageBox(NULL, szStringSpace, "QvElement::print",MB_ICONINFORMATION) ;
#else
    printf("\t\tElement of type %s\n", nodeTypeNames[type]);
#endif    
}
